
var json_array = [];
$(document).ready(function () {
    $('#tblProduct').DataTable({
        "scrollX": true,
        "order": [],
        "columns": [
            { "data": "description" },
            { "data": "view" },
            { "data": "approval" },

        ],
        columnDefs: [
            { width: 40, targets: 1 },
            { width: 40, targets: 2 },
        ],
    });

    allNotification();

});



function allNotification() {
    $.ajax({
        type: "GET",
        url: "/st/approval/allUserApprovalList",
        async: false,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                appendTableRow(result);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}





function appendTableRow(result) {

    var data = [];
    for (i = 0; i < result.length; i++) {


        var rollback_id = result[i]['id'];
        var string_id = "'" + rollback_id + "'";
        var description = result[i]['description'];
        var slug_id = result[i]['slug_id'];
        var string_slug_id = "'" + slug_id + "'";
        var rule_id = result[i]['rule_id'];
        var string_rule_id = "'" + rule_id + "'";
        var prioraty = result[i]['prioraty'];



        data.push({
            'description': description,
            'view': '<button class="btn btn-success" type="button" onclick="viewAction(' + string_id + ')">View</button>',
            'approval': '<button class="btn btn-primary" type="button" onclick="approvedAction(' + string_id + ',' + string_slug_id + ',' + string_rule_id + ')">Approval</button>'
        });

    }



    var table = $('#tblProduct').DataTable();
    table.clear();
    table.rows.add(data).draw();

}



function viewAction(id) {
    $.ajax({
        type: "GET",
        url: "/st/approval/employee/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var result = response.data.result;
                if (result) {
                    var tbody = "";
                    for (var i = 0; i < result.length; i++) {

                        if (result[i].value ) {

                            var row = "<tr>";
                            row += "<td>" + result[i].field_name + "</td>";
                            row += "<td>" + result[i].value + "</td>";
                            row += "</tr>"
                            tbody += row;
                        }else{
                            var row = "<tr>";
                            row += "<td>" + result[i].field_name + "</td>";
                            row += "<td></td>";
                            row += "</tr>"
                            tbody += row; 
                        }


                    }

                    $('#tblData').empty();
                    $('#tblData').append(tbody);
                }

                $("#approvalActionModal").modal('toggle');

            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}



function approvedAction(rollback_id, slug_id, rule_id) {
    var _token = $("input[name='_token']").val();

    $.ajax({
        type: 'PUT',
        url: '/st/approval/approvedAction/' + rollback_id + "/" + slug_id + "/" + rule_id,
        data: { "_token": _token, },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var status = response.data.result;
                if (status == 0) {
                    showWarningMessage('Not available prioraty...!');
                } else if (status == 1) {
                    showSuccessMessage('Approval has been successfully...');
                }

                allNotification();
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}
